VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCustomers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' These property values will be displayed on frmDemo
Public CustomerID As String
Public CompanyName As String
Public Address As String
Public City As String
Public PostalCode As String

' We will get above property values from rsCustomers
Private rsCustomers As ADODB.Recordset

' The value of CustomerID will determine Orders Records
Public WithEvents Orders As clsOrders
Attribute Orders.VB_VarHelpID = -1

' Events to notify frmDemo that values have changed and therefore update display
Public Event CustomerDataChg()
Public Event OrderDataChg()
Public Event DetailsDataChg()

Public Sub GetCustomers()
' set our connection
Dim cn As ADODB.Connection
Set cn = New ADODB.Connection
cn.CursorLocation = adUseClient
cn.Open "PROVIDER=Microsoft.Jet.OLEDB.4.0;Data Source=" & _
    DB_PATH & ";"

' get our recordset
Set rsCustomers = New ADODB.Recordset
Dim sql As String
sql = "SELECT CustomerID, CompanyName, Address, City, PostalCode FROM Customers " & _
        "ORDER BY CompanyName;"
rsCustomers.Open sql, cn, adOpenStatic, adLockOptimistic

' set a new instance of Orders
Set Orders = New clsOrders

Call UpdateValues       ' update our properties to be displayed on frmDemo

End Sub

Private Sub Orders_DetailsChg()
' pass event on to frmDemo
RaiseEvent DetailsDataChg
End Sub

Private Sub Orders_OrderInfoChg()
' pass event on to frmDemo
RaiseEvent OrderDataChg
End Sub

Public Sub MoveFirst()
rsCustomers.MoveFirst
Call UpdateValues
End Sub

Public Sub MoveLast()
rsCustomers.MoveLast
Call UpdateValues
End Sub

Public Sub MovePrevious()
With rsCustomers
    .MovePrevious
    If .BOF Then .MoveFirst     ' prevent going off beginning of recordset
End With
Call UpdateValues
End Sub

Public Sub MoveNext()
With rsCustomers
    .MoveNext
    If .EOF Then .MoveLast      ' prevent going off end of recordset
End With
Call UpdateValues
End Sub

Private Sub UpdateValues()
' update our properties to be displayed on frmDemo
With rsCustomers
    CustomerID = !CustomerID & ""
    CompanyName = !CompanyName & ""
    Address = !Address & ""
    City = !City & ""
    PostalCode = !PostalCode & ""
    Orders.CustomerID = CustomerID  ' establish a new Orders recordset
End With
' tell frmDemo values have changed
RaiseEvent CustomerDataChg
End Sub

Private Sub Class_Terminate()
' close recordset
rsCustomers.Close
End Sub
